// Author: George W. Taylor
// http://www.tropicalcoder.com/
// Date: 15 Oct 2012
// License: Creative Commons - Non-Commercial Use

#ifndef ASIO_SUPPORT
	#define ASIO_SUPPORT

#include <Windows.h>
#include "ASIOHost.h"


class ASIO_IO
{
public:
 ASIO_IO(HWND hWnd);
 ~ASIO_IO();
 void KeyOn(void);
 void KeyOff(DWORD dwDurationMicroseconds);
 void Shutdown(void);

private:
 bool ShowASIODevices(int *pNumDevs);
 void PrepareVirtualChannels(void);
 void InitializeToneGenerator(void);

 friend void SendOutgoingAudio(LPBYTE pSndBuf, DWORD dwBufsizeBytes, DWORD dwInstanceData);
 friend void CalculateTotalFallTimeSamples(ASIO_IO *pObj);
 friend void WrapUp(ASIO_IO *pObj, double *pAmplitude);


 ChannelVars StereoChannelVars;

 double dRadians;
 double dPhaseAngle;
 double dbLevel;
 double dAmplitude;
 double dWaveLength;
 double dSampleMicroseconds;

 DWORD dwSampleRate;
 DWORD dwBufferSampleSize;
 DWORD dwCountSamples;
 DWORD dwTotalDurationSamples;
 DWORD dwIntegralWaveLength;
 DWORD dwHalfIntegralWaveLength;

 DWORD dwCountBuffers; // for testing & debugging only

 DWORD dwTotalRiseTimeSamples;
 DWORD dwTotalFallTimeSamples;
 DWORD dwCalculatedFallTimeSamples;
 DWORD dwCountRiseTimeSamples;
 DWORD dwCountFallTimeSamples;

 bool bRising;
 bool bFalling;
 bool bCheckSampleCount;
 bool bUsingDecayDelay;
 bool bKeyedOn;
 bool bASIOInitialized;
 bool bCreatedStereoVirtualChn;
};

#endif