// Author: George W. Taylor
// http://www.tropicalcoder.com/
// Date: 15 Oct 2012
// License: Creative Commons - Non-Commercial Use

#include "stdafx.h"
#include "CParams.h"


// Initialize with default values in case there is no ini file found
char CParams::sPort[8] = "COM1";
char CParams::sComEventMonitored[8] = "DSR";
double CParams::dAttenuation = 3.0;
double CParams::dFrequency = 1000.0;
double CParams::dRiseTime = 0.01;
double CParams::dFallTime = 0.01;
int CParams::iASIODevNum = 0;
int CParams::iDebounceDelay = 0;


// This function loads in the parameters from a given file name. 
// Returns false if there is a problem opening the file.
bool CParams::LoadInParameters(char* szFileName)
{
  ifstream grab(szFileName);

  //check file exists
  if (!grab)
  {
    return false;
  }

  // load in from the file
  char ParamDescription[40];

  grab >> ParamDescription;
  grab >> iASIODevNum;
  grab >> ParamDescription;
  grab >> dAttenuation;
  grab >> ParamDescription;
  grab >> dFrequency;
  grab >> ParamDescription;
  grab >> dRiseTime;
  grab >> ParamDescription;
  grab >> dFallTime;
  grab >> ParamDescription;
  grab >> sPort;
  // A safer way to deal with a string which potentially couild be any length
  // is to simply null it out after however many characters we are interested in.
  // This has the added advantage of ensuring it is null terminated.
  sPort[4] = '\0'; 
  _toupper(sPort);
  grab >> ParamDescription;
  grab >> sComEventMonitored;
  sComEventMonitored[3] = '\0';
  _toupper(sComEventMonitored);
  grab >> ParamDescription;
  grab >> iDebounceDelay;
  return true;
}
 




  
  
